use diesel_migrations::EmbeddedMigrations;
use lib::diesel::migration::run_migrations;
use lib::test::test_containers::{ContainerError, TestContainer};

pub async fn create_test_containers_pool() -> Result<TestContainer, ContainerError> {
    let test_container = lib::test::test_containers::create_test_containers_pool().await?;
    let connection = test_container.pool.get().await?;
    const MIGRATIONS: EmbeddedMigrations = diesel_migrations::embed_migrations!("./migrations");
    run_migrations(connection, MIGRATIONS).await?;
    Ok(test_container)
}
