{
  inputs = {
    nixpkgs.url = "github:NixOS/nixpkgs/nixos-25.05";
    nixpkgs-unstable.url = "github:NixOS/nixpkgs/nixos-unstable";
  };

  outputs = { nixpkgs, nixpkgs-unstable, ... }:
    let
      system = "x86_64-linux";
    in
    {
      devShells.${system}.default =
        let
          pkgs = import nixpkgs {
            inherit system;
          };
          unstable = import nixpkgs-unstable {
            inherit system;
          };
        in
        pkgs.mkShell {
          packages = with pkgs; [
            git
            just
          ] ++ [
            # Rust
            gcc
            # cargo
          ] ++ [
            # Diesel
            diesel-cli
            unstable.libpq
          ];

          shellHook = "fish";
        };
    };
}
