use crate::axum::traits::BuildJson;
use axum::body::Body;
use axum::http::Request;
use axum::http::header::CONTENT_TYPE;
use mime::APPLICATION_JSON;
use serde::Serialize;
use serde_json::json;

impl BuildJson for axum::http::request::Builder {
    fn json<T: Serialize>(self, body: T) -> Result<Request<Body>, axum::http::Error> {
        self.header(CONTENT_TYPE, APPLICATION_JSON.as_ref())
            .body(Body::new(json!(body).to_string()))
    }
}
